<?php
/*
Plugin Name: Digg This Reloaded
Version: 1.3 Alpha
Plugin URI: http://dev.lipidity.com/dev/web/share-this-reloaded-digg-with-a-difference
Author: Ankur Kothari
Author URI: http://dev.lipidity.com/
Description: Adds Digg story link/button to your posts as well as options to submit to other social bookmarking sites.
*/ 

/*
http://dev.lipidity.com/ for any help/support/requests/suggestions/updates
or send me an email at admin@lipidity.com

This is my first Wordpress plugin, so play nice!
*/

// set this to false if you do not want to automatically add the Share This link to your content
@define('AKST_ADDTOCONTENT', get_option('digg_showShare'));
@define('AKST_ADDTOFOOTER', get_option('digg_showShare'));


/* No more editing. To make changes, go to your Wordpress admin panel, then to Share This under options. */

if(!get_option('digg_appendType') && !$_REQUEST['appendType']){
	resetEverything();
}

function resetEverything(){
	update_option('digg_append',1);
	update_option('digg_curl',1);
	update_option('digg_appendType','button');
	update_option('digg_submitLink',1);
	update_option('digg_notify',1);
	$conditions1 = Array();
	$conditions1['is_single'] = true;
	$conditions1['is_home'] = false;
	$conditions1['is_page'] = true;
	$conditions1['is_category'] = false;
	$conditions1['is_date'] = false;
	update_option('digg_conditionals',$conditions1);
	update_option('digg_before', "<div class='diggWrap'>");
	update_option('digg_after', "</div>");
	update_option('digg_whats_this', 1);
	update_option('digg_txt', 'Digg this story');
	update_option('digg_button', 'http://digg.com/img/badges/32x32-digg-guy.gif');
	update_option('digg_showShare', 1);
	update_option('digg_shareTxt', 'Share elsewhere');
}
if(!get_option('digg_conditionals'))add_option('digg_conditionals',Array());

if (get_option('digg_append')) {
	add_filter('the_content', 'digg_button_hook');
}

function digg_button_hook($content = ''){
		$conditionals = get_option('digg_conditionals');
		if ((is_home() and $conditionals['is_home']) or
		    (is_single() and $conditionals['is_single']) or
		    (is_page() and $conditionals['is_page']) or
		    (is_category() and $conditionals['is_category']) or
		    (is_date() and $conditionals['is_date']) or 0)
		{
			$appendType = get_option('digg_appendType');
			$showButton = ($appendType=="text") ? false : true;
			//if(!get_option('digg_before'))update_option('digg_before','');
			//if(!get_option('digg_after'))update_option('digg_after','');
			//if(!get_option('digg_whats_this'))update_option('digg_whats_this',0);
			
			$content .= get_option('digg_before') . digg_this_reloaded(get_option('digg_txt'), "", get_option('digg_whats_this'), $showButton) . get_option('digg_after');
		}
		return $content;
}

// Hook the admin_menu display to add admin page
add_action('admin_menu', 'digg_admin_menu');
function digg_admin_menu() {
	//add_submenu_page(parent, page_title, menu_title, access_level/capability, file, [function]);
	add_submenu_page('options-general.php', 'Share This Options', 'Share This', 8, 'digg-this', 'digg_this_menu');
}

// Admin page header
add_action('admin_head', 'digg_admin_head');

function digg_admin_head() {
	if(str_replace('digg-this', '', $_SERVER['REQUEST_URI']) != $_SERVER['REQUEST_URI']){
?>
 <script src="<? echo get_bloginfo('wpurl'); ?>/wp-content/plugins/digg-this/js/addEvent.js"></script>
 <script src="<? echo get_bloginfo('wpurl'); ?>/wp-content/plugins/digg-this/js/sweetTitles.js"></script>
 <style>
   @import "<? echo get_bloginfo('wpurl'); ?>/wp-content/plugins/digg-this/css/sweetTitles.css";
 </style>
 <?
	}
}

function clear_all_options(){
	delete_option('digg_submitLink');
	delete_option('digg_append');
	delete_option('digg_appendType');
	delete_option('digg_button');
	delete_option('digg_conditionals');
	delete_option('digg_before');
	delete_option('digg_after');
	delete_option('digg_whats_this');
	delete_option('digg_txt');
	delete_option('digg_notify');
	delete_option('digg_curl');
	delete_option('digg_curl');
	delete_option('digg_showShare');
	delete_option('digg_shareTxt');
}

function digg_this_menu() {

	if ($_REQUEST['save']) {
		// update active sites
		update_option('digg_submitLink', $_REQUEST['submitLink']);

		// update conditional displays
		$conditionals = Array();
		if (!$_REQUEST['conditionals'])
			$_REQUEST['conditionals'] = Array();
		foreach(get_option('digg_conditionals') as $condition=>$toggled)
			$conditionals[$condition] = array_key_exists($condition, $_REQUEST['conditionals']);
		update_option('digg_conditionals', $conditionals);

/*		if (!$_REQUEST['append'])
			$_REQUEST['append'] = "";
		update_option('digg_append', $_REQUEST['append']);*/

		update_option('digg_append', $_REQUEST['append']);
		
		update_option('digg_appendType', $_REQUEST['appendType']);
		update_option('digg_before', str_replace('"',"'", stripslashes($_REQUEST['prefix'])));
		update_option('digg_after', str_replace('"',"'", stripslashes($_REQUEST['suffix'])));

		update_option('digg_whats_this', $_REQUEST['linkBack']);
		update_option('digg_notify', $_REQUEST['notify']);
		update_option('digg_curl', $_REQUEST['curl']);
						
		update_option('digg_button', ($_REQUEST['diggButton'])?$_REQUEST['diggButton']:"http://digg.com/img/badges/32x32-digg-guy.gif");
		
		update_option('digg_showShare', $_REQUEST['showShare']);
		update_option('digg_shareTxt', $_REQUEST['shareTxt']);
		
		echo '<div id="message" class="updated fade"><p>Saved changes.</p></div>';
	}  else if($_REQUEST['clear']){
	clear_all_options();
	resetEverything();
	echo '<div id="message" class="error fade"><p>Plugin cleared.</p></div>';
//	echo "<!--"; //-->
	}

	// load options from db to display
	$conditionals = get_option('digg_conditionals');
	$append = get_option('digg_append');
	$submitLink = get_option('digg_submitLink');
	$appendType = get_option('digg_appendType');
	$diggButton = get_option('digg_button');
	$before = get_option('digg_before');
	$after = get_option('digg_after');
	$linkBack = get_option('digg_whats_this');
	$notify = get_option('digg_notify');
	$curlScrape = get_option('digg_curl');
	$showShare = get_option('digg_showShare');
	$shareTxt = get_option('digg_shareTxt');
	// display options
?>

<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post" id="form1" name="form1">

<div class="wrap" id="digg_options">
<fieldset>
<h2>Share This Plugin Setup</h2>
<? echo ($append) ? "" : "<div id='message' class='error fade'><p>Plugin not appending. <abbr title='You have disabled appending the Digg option to your posts automatically. For the Digg option to show, you need to add it to your template.'>[ ? ]</abbr></p></div>"; ?>
<h3>Set up your blog&#39;s integration with Digg.com</h3>

<div class="wrap">
<h3>Digg option</h3>
<p>Select the type of Digg option you want to provide your users. From here on in, this selection will be referred to as the &quot;Digg option&quot;.</p>
<p><select name="appendType"><option value="button"<?php echo ($appendType=="button") ? " selected" : ""; ?>>Button</option>
<option value="text"<?php echo ($appendType=="text") ? " selected" : ""; ?>>Text Link</option>
</select> <abbr title="The setting you choose here will determine how the Digging option will look. Setting it to button will produce an iframe allowing the user to Digg the post, or setting a simple text link will show exactly that; a text link! When you hear &quot;Digg option&quot; from now on, it means button or text link, depending on which one you&#39;ve chosen here.">[?]</abbr></p>

<p><input type="checkbox" id="linkBack" name="linkBack"<?php echo ($linkBack) ? " checked" : "" ?> /> <label for="linkBack">Show what&#39;s this link.</label></p>
</div>

<div class="wrap">
<h3>Show Digg Button</h3>
<p>Digg This can automatically add a Digg option to the end of each post.</p>
<table width="100%"><tr><td><label for="append">Enable automatic append of Digg option to posts.</td>
<td width="53%"><input type="checkbox" id="append" name="append"<?php echo ($append) ? " checked" : ""; ?> /> <abbr title="If you want the Digg button appearing at the bottom of your posts, check this option. Otherwise you can edit your template directly to get it to show by using the digg_this_reloaded function.">[?]</abbr></td></tr>
</table>

<p>Append Digg option to posts on: <abbr title="Choose which pages you want the Digg option to appear on.">[?]</abbr></p>
<ul style="list-style-type: none">
	<li><input type="checkbox" name="conditionals[is_home]" id="conditionals[is_home]"<?php echo ($conditionals['is_home']) ? " checked" : ""; ?>> <label for="conditionals[is_home]">Front page of the blog</label></li>
	<li><input type="checkbox" name="conditionals[is_single]" id="conditionals[is_single]"<?php echo ($conditionals['is_single']) ? " checked" : ""; ?>> <label for="conditionals[is_single]">Individual blog posts</label></li>
	<li><input type="checkbox" name="conditionals[is_page]" id="conditionals[is_page]"<?php echo ($conditionals['is_page']) ? " checked" : ""; ?>> <label for="conditionals[is_page]">Individual WordPress &quot;Pages&quot;</label></li>
	<li><input type="checkbox" name="conditionals[is_category]" id="conditionals[is_category]"<?php echo ($conditionals['is_category']) ? " checked" : ""; ?>> <label for="conditionals[is_category]">Category archives</label></li>
	<li><input type="checkbox" name="conditionals[is_date]" id="conditionals[is_date]"<?php echo ($conditionals['is_date']) ? " checked" : ""; ?>> <label for="conditionals[is_date]">Date-based archives</label></li>
</ul>

</div>

<div class="wrap">
<h3>Undugg posts</h3>
<table width="100%"><tr><td><label for="submitLink">When post hasn&#39;t been dugg, show submit to Digg option</label></td>
<td><input type="checkbox" id="submitLink" name="submitLink"<?php echo ($submitLink) ? " checked" : ""; ?> /> <abbr title="If the post hasn't been dugg, you have the choive of either showing nothing by leaving this unchecked, or you can give your users a link to submit your post to Digg.com by ticking this checkbox.">[?]</abbr></td></tr>

<tr><td>Button to use (if Digg option is button)</td>
<td><input type="text" size="50" id="diggButton" name="diggButton" value=<?php echo ($diggButton) ? "'$diggButton'" : "''"; ?> /> <abbr title="If you're showing a &#39;submit to Digg&#39; link, and you've set button as your Digg option, you can change the image that appears here to link to the Digg submission form. The default is usually fine.<br />Preview: <img src='<? echo $diggButton ?>' />">[?]</abbr></td></tr>

<tr><td><label for="notify">Email admin when post is dugg?</label></td>
<td><input type="checkbox" id="notify" name="notify"<?php echo ($notify) ? " checked" : ""; ?> /> <abbr title="If you want an email sent to you once a post has been dugg, tick this checkbox.">[?]</abbr></td></tr>

<tr><td><label for="curl">Ensure that the Digg referrer is really for your post?</label></td>
<td><input type="checkbox" id="curl" name="curl"<?php echo ($curlScrape) ? " checked" : ""; ?> /> <abbr title="If you would like to the plugin to connect to the Digg page to make sure it's the correct Digg page, and not a comment or other link that's sent the referrer, tick this box. This way you don't have to check all your Dugg posts to make sure they're correct links.">[?]</abbr></td></tr>

</table>
</div>

<div class="wrap">
<h3>Styling</h3>
<p>If you want, you can wrap the Digg option in HTML tags for styling or positioning purposes.</p>
<table width="100%">
<tr><td><label for="prefix">Prefix: </label></td>
<td><input type="text" id="prefix" name="prefix" value="<?php echo $before; ?>" /> <abbr title="The HTML you want to have before the button. Most likely an opening tag such as div, p or span. Single quotes only.">[?]</abbr></td></tr>

<tr><td><label for="suffix">Suffix: </label></td>
<td><input type="text" id="suffix" name="suffix" value="<?php echo $after; ?>" /> <abbr title="This bit goes after the Digg option. You&#39;ll want to close any tags you have opened in the prefix. Single quotes only.">[?]</abbr></td></tr>
</table>
</div>

<h2>More social bookmarking</h2>
<h3>Integrations with Technorati, Delicious, Reddit, etc.</h3>
<div class="wrap">
<h3>Share this</h3>
<p>This enables a link on your posts to allow integration with other social bookmarking sites.</p>
<table width="100%">
<tr><td><label for="prefix">Use share this link: </label></td>
<td><input type="checkbox" id="shareShow" name="shareShow"<?php echo ($showShare) ? " checked" : ""; ?> /> <abbr title="Enabling this option will show a link after the Digg button that will allow the user to submit your article to other sites as well as Digg, including Delicious, Technorati, Reddit and more.">[?]</abbr></td></tr>

<tr><td><label for="suffix">Share this link: </label></td>
<td><input type="text" id="shareTxt" name="shareTxt" value="<?php echo $shareTxt; ?>" /> <abbr title="The text or HTML you want displayed as the link to open up the share this box.">[?]</abbr></td></tr>
</table>
</div>


</fieldset>
<script>
/*
<? //echo $_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']."?".$_SERVER['QUERY_STRING']."&clear=1" ?>
*/
</script>
<p class="submit"><input name="clear" id="reset" accesskey="s" style='width:150px' value="Reset Options" type="submit" />
<input name="save" id="save" style='width:150px' accesskey="r" value="Save Changes" type="submit" /></p>
</div>
</form>

<?php
//if($_REQUEST['clear'])echo "//-->";
}

function _scrape_check_digg($digg_link, $the_permalink)
{    
    $ch = curl_init(); 
    curl_setopt($ch, CURLOPT_URL, $digg_link); 
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);         
    $http_result = curl_exec($ch);
    curl_close($ch);            
    $_ = preg_match('#<h3 id="title"><a href="(.*?)">#is', $http_result, $captures);
    return ($captures[1] == $the_permalink);
}

function digg_this_button()
{
   return digg_this_reloaded("","",false,true);
}

function digg_this_reloaded($link_text="Digg this story", $ping_str="", $show_what_is_this=true, $use_digg_button=false)
{
//   global $id;
	$result = "";
	global $wp_query; 
	$post = $wp_query->post;
	$id = $post->ID;
	$permalink = get_permalink($id);
	$title = urlencode($post->post_title);
	
   $WHAT_IS_THIS_TEXT = 'Learn more about the Digg This Reloaded plugin for Wordpress.';
   $orig_ref = $_SERVER['HTTP_REFERER'];
   $ref = strtolower($orig_ref);
   $referer_end = substr($orig_ref, -10);
   $digg_link = get_post_meta($id, 'DiggUrl', true);
   
   if ( $digg_link == '' && substr_count($ref, "_") > 0
   	&& strpos($ref, "digg.com") !== false
        && strpos($ref, "?") == false
        &&
        (strpos($ref, "digg.com")==0 || 
    	strpos($ref, "http://digg.com")==0 ||
    	strpos($ref, "www.digg.com")==0 ||
    	strpos($ref, "http://www.digg.com")==0)
      )
      { 
	$CURLCheck = (get_option('digg_curl')) ? _scrape_check_digg($_SERVER['HTTP_REFERER'], get_permalink()) : true;
    if($CURLCheck){
      	/* this removes /who, /blog, and /share from the path */ 
	     
	    if(strpos($referer_end, "/who")) {
		$orig_ref = substr($referer, 0, $referer_len-4);
	    }
	    if(strpos($referer_end, "/blog")) {
		$orig_ref = substr($referer, 0, $referer_len-5);
	    }
	    if(strpos($referer_end, "/share")) {
		$orig_ref = substr($referer, 0, $referer_len-6);
	    }
	    
        $digg_link=$orig_ref; 
        add_post_meta($id, 'DiggUrl', $orig_ref);
        if(get_option ('digg_notify')) notify_moderator_on_digg($id, $orig_ref);
     }
      }

   if (substr_count(strtolower($digg_link),"digg.com"))
  	{
                if ($use_digg_button)
                {
//		  $result .= "<link rel='plugin' title='Digg This - Wordpress Plugin' href='http://dev.lipidity.com/feature/digg-this-wordpress-plugin-reloaded' />";
                  $result .= "<script type='text/javascript'>";
                  $result .= "//<![CDATA[\ndigg_url='".$digg_link."';\n//]]>\n";
                  $result .= "</script>\n<script type='text/javascript' src='http://digg.com/api/diggthis.js'>\n</script>\n";
                  /*$result .= "<iframe src='http://digg.com/api/diggthis.php?u=".htmlspecialchars($digg_link)."' height='82' width='55' frameborder='0' scrolling='no'></iframe>";*/
                }
                else
                {
  		     $result .= "<a href='".$digg_link."' ping='".$permalink."$ping_str' target='_blank' title='Digg this story'>".$link_text."</a>";
		     $result .= '&nbsp;<font size="-2"><a href="http://dev.lipidity.com/feature/digg-this-wordpress-plugin-reloaded" title="'.$WHAT_IS_THIS_TEXT.'">';
		if ($show_what_is_this) $result .= '[ ? ]';
 		     $result .= ' </a></font>';
                }
  	
  	} else if(get_option('digg_submitLink')) {

		if ($use_digg_button){
			$result .= "<a href='http://digg.com/submit?phase=2&amp;url=".htmlspecialchars($permalink)."&amp;title=".urlencode($post->post_title)."&amp;topic=' title='Bookmark this story on Digg.com'><img src='". get_option('digg_button') ."' class='imgDigg' alt='Digg!' /></a>";
		} else {
			$result .= "<a href='http://digg.com/submit?phase=2&amp;url=".htmlspecialchars($permalink)."&amp;title=".urlencode($post->post_title)."&amp;topic=' title='Bookmark this story on Digg.com' class='txtDigg'>Digg it</a>";
		}
	}
	return $result;
}  

function notify_moderator_on_digg($post_id, $digg_ref ) {
	global $wpdb;
        
	//if( get_settings( "moderation_notify" ) == 0 )
	//	return true; 
    
	
	$post = $wpdb->get_row("SELECT * FROM $wpdb->posts WHERE ID='$post_id' LIMIT 1");

	$notify_message  = sprintf( __('A new post was dugg by digg.com users. A link back to digg.com ( %1$s ) was automaticaly added to the post #%2$s "%3$s" 

'), $digg_ref, $post_id, $post->post_title ) . "\r\n";
	$notify_message .= get_permalink($post->ID) . "\r\n\r\n";
	$subject = sprintf( __('[%1$s] A post has been dugg: "%2$s"'), get_settings('blogname'), $post->post_title );
	$admin_email = get_settings('admin_email');

	$notify_message = apply_filters('post_dugg_text', $notify_message);
	$subject = apply_filters('post_dugg_subject', $subject);

	@wp_mail($admin_email, $subject, $notify_message);
    
	return true;
}

	if(get_option('digg_showShare')){
		include_once 'share-this/share-this.php';
	}

?>